#ifndef LIBSARIA_FILES_H
#define LIBSARIA_FILES_H

#include <libsaria/idle.h>
#include <libsaria/print.h>

#include <sys/types.h>
#include <fstream>
using namespace std;

class SaveTask : public IdleTask
{
	private:
		void (* save_func)();

	public:
		SaveTask(void (*func)());
		~SaveTask();
		void run_task();
};

class LoadTask : public IdleTask
{
	private:
		void (*load_func)();

	public:
		LoadTask(void (*func)());
		~LoadTask();
		void run_task();
};

class OutFile : public ofstream
{
	public:
		OutFile(string);
		~OutFile();
		OutFile& operator<<(const char *);
		OutFile& operator<<(string);
		template <class T>
		OutFile& operator<<(T);
};

class InFile : public ifstream
{
	public:
		InFile(string);
		~InFile();
		InFile& operator>>(string &);
		template <class T>
		InFile& operator>>(T &);
};

template <class T>
OutFile& OutFile::operator<<(T item)
{
	ofstream *out = (ofstream *)this;
	*out << item << " ";
	return *this;
}

template <class T>
InFile& InFile::operator>>(T &item)
{
	ifstream *in = (ifstream *)this;
	*in >> item;
	return *this;
}

#endif /* LIBSARIA_FILES_H */
