#ifndef LIBSARIA_LIBRARY_PATH_H
#define LIBSARIA_LIBRARY_PATH_H

#include <libsaria/library.h>
#include <libsaria/track.h>

#include <list>
#include <string>
using namespace std;

namespace libsaria
{
	class LibraryPath {
		private:
			string path;
			list<libsaria::Track *> file_list;
			bool has_id(sid_t);

		public:
			LibraryPath();
			LibraryPath(string);
			~LibraryPath();

			void load_file(InFile &);
			string get_path();
			unsigned int get_size();
			void prepare_for_removal();
			void get_info(void (*)(struct libsaria::library::PathInfo &));
			bool add_track(string &, sid_t &);
			void validate_track(libsaria::Track *);
			void save(OutFile &);

			void update();
			void validate();
	};
}; /* Namespace: libsaria */

#endif /* LIBSARIA_LIBRARY_PATH_H */
