/*
 * Manages the libsaria library save file
 */

#include <libsaria/idle.h>
#include <libsaria/library.h>
#include <libsaria/libpath.h>
#include "list/list.h"
#include "library.h"

static void do_load()
{
	unsigned int size;
	InFile in("library.lib");

	if (!in.good())
		return;
	in >> size;

	for (unsigned int i = 0; i < size; i++) {
		path_list.push_back(libsaria::LibraryPath());
		path_list.back().load_file(in);
	}

	libsaria::library::sort_list();
	libsaria::library::refresh();
}

namespace libsaria
{

	void library::load()
	{
		LoadTask *task = new LoadTask(do_load);
		task->queue();
	}

	void library::save()
	{
		OutFile out("library.lib");
		list<libsaria::LibraryPath>::iterator it;

		out << path_list.size() << "\n";
		for (it = path_list.begin(); it != path_list.end(); it++)
			it->save(out);
	}

}; /* namespace: libsaria */
