
#include <libsaria/libpath.h>

#include <string>
using namespace std;

namespace libsaria
{

	LibraryPath::LibraryPath()
	{
	}

	LibraryPath::LibraryPath(string dir)
	{
		path = dir;
	}

	LibraryPath::~LibraryPath()
	{
		list<libsaria::Track *>::iterator it;
		for (it = file_list.begin(); it != file_list.end(); it++)
			delete (*it);
	}

	void LibraryPath::prepare_for_removal()
	{
		list<libsaria::Track *>::iterator it;
		for (it = file_list.begin(); it != file_list.end(); it++)
			(*it)->do_cleanup();
	}

	string LibraryPath::get_path()
	{
		return path;
	}

	unsigned int LibraryPath::get_size()
	{
		return file_list.size();
	}

	void LibraryPath::get_info(void (*info_func)(struct libsaria::library::PathInfo &))
	{
		struct libsaria::library::PathInfo info;
		info.path = path;
		info.size = file_list.size();
		info_func(info);
	}

	bool LibraryPath::has_id(sid_t id)
	{
		list<libsaria::Track *>::iterator it;
		for (it = file_list.begin(); it != file_list.end(); it++) {
			if ((*it)->get_songid() == id)
				return true;
		}
		return false;
	}

} /* Namespace: libsaria */
