
#include <stdlib.h>

#include <libsaria/libsaria.h>
#include <libsaria/audio.h>
#include <libsaria/path.h>
#include <libsaria/prefs.h>
#include <libsaria/print.h>
#include <libsaria/queue.h>
#include <libsaria/library.h>
#include <libsaria/format.h>
#include <libsaria/index.h>

namespace libsaria
{

	void init(int argc, char **argv)
	{
		srand( time(NULL) );
		println("Initializing libsaria");
		libsaria::prefs::load();
		audio::init(argc, argv);
		println("saria dir: %s", get_saria_dir().c_str());
		make_saria_dir();
		libsaria::library::load();
		libsaria::queue::load();
	}

	void quit()
	{
		println("Quitting libsaria");
		audio::quit();
		print_format_stats();
		index::print_stats();
		close_pipes();
	}

};
