
#include <libsaria/files.h>
#include <libsaria/path.h>

SaveTask::SaveTask(void (*func)())
{
	save_func = func;
}

SaveTask::~SaveTask()
{
}

void SaveTask::run_task()
{
	save_func();
}

LoadTask::LoadTask(void (*func)())
{
	load_func = func;
}

LoadTask::~LoadTask()
{
}

void LoadTask::run_task()
{
	load_func();
}

OutFile::OutFile(string path)
{
	string out_file = get_saria_dir() + "/" + path;
	open(out_file.c_str());
}

OutFile::~OutFile()
{
	close();
}

OutFile& OutFile::operator<<(string s)
{
	ofstream *out = (ofstream *)this;
	*out << s.size() << " " << s << " ";
	return *this;
}

OutFile& OutFile::operator<<(const char*s)
{
	ofstream *out = (ofstream *)this;
	*out << s;
	return *this;
}

InFile::InFile(string path)
{
	string in_file = get_saria_dir() + "/" + path;
	open(in_file.c_str());
	if (!good())
		println("Error opening file: " + in_file);
}

InFile::~InFile()
{
	close();
}

InFile& InFile::operator>>(string &res)
{
	int len;
	res = "";

	*this >> len;
	if (len == 0)
		return *this;

	len++;
	this->get();
	char c[len];
	this->get(c, len);
	res = c;
	return *this;
}
