
#include <libsaria/idle.h>
#include <libsaria/callback.h>
#include <libsaria/queue.h>
#include "queue.h"

static void do_load()
{
	unsigned int size;
	sid_t songid;
	InFile in("queue.q");

	if (!in.good())
		return;
	in >> size;

	for (unsigned int i = 0; i < size; i++) {
		in >> songid;
		playqueue.push_back(songid);
	}

	trigger_callback(QUEUE_REFRESH);
}

static void do_save()
{
	OutFile out("queue.q");
	list<sid_t>::iterator it;

	out << playqueue.size() << "\n";
	for (it = playqueue.begin(); it != playqueue.end(); it++)
		out << (*it) << "\n";
}

namespace libsaria
{

	void queue::load()
	{
		LoadTask *task = new LoadTask(do_load);
		task->queue();
	}

	void queue::save()
	{
		SaveTask *task = new SaveTask(do_save);
		task->queue_front();
	}

}
