
#include <ocarina/header.h>
#include <libsaria/index.h>
#include <libsaria/print.h>
#include "header.h"

#include <list>
using namespace std;

static list<GtkWidget *>entries;

static GtkWidget *find_current_entry()
{
	list<GtkWidget *>::iterator it;
	for (it = entries.begin(); it != entries.end(); it++) {
		if (gtk_widget_get_mapped(*it))
			return *it;
	}

	return NULL;
}

void focus_entry()
{
	GtkWidget *entry = find_current_entry();
	if (entry != NULL)
		gtk_widget_grab_focus(entry);
}

static void do_filter(GtkWidget *entry)
{
	string text = gtk_entry_get_text(GTK_ENTRY(entry));
	libsaria::index::filter(text);
}

GtkWidget *get_entry()
{
	GtkWidget *entry = gtk_entry_new();
	GTK_CONNECT(entry, "changed", do_filter, NULL);
	entries.push_back(entry);
	return entry;
}

bool entry_focused()
{
	GtkWidget *entry = find_current_entry();
	return gtk_widget_is_focus(entry);
}
