// Copyright (c) Bryan Schumaker 2012.
#include <libsaria/path.h>
#include <libsaria/print.h>
#include <libsaria/audio.h>
#include <libsaria/controls.h>
#include <ocarina/ocarina.h>

#include <glib.h>
#include <string>
using namespace std;

static GIOChannel *pipe_in;

void perform_action(string action)
{
	if (action == "play")
		libsaria::audio::play();
	else if (action == "pause")
		libsaria::audio::pause();
	else if (action == "stop")
		libsaria::audio::stop();
	else if (action == "next")
		libsaria::next();
}

string pipe_read_text(GIOChannel *source)
{
	gchar *str = NULL;
	GError *error = NULL;
	gsize size, end;
	string text;

	g_io_channel_read_line(source, &str, &size, &end, &error);
	text = str;

	/* g_io_channel_read_line allocates memory */
	g_free(str);
	return text.substr(0, size-1);
}

gboolean pipe_read(GIOChannel *source, GIOCondition condition, gpointer data)
{
	string action = pipe_read_text(source);
	perform_action(action);
	return TRUE;
}

namespace ocarina
{
	void init_pipe()
	{
		GError *error = NULL;
		string pipe = open_pipe("ocarina.pipe");
		if (pipe == "")
			return;

		pipe_in = g_io_channel_new_file(pipe.c_str(), "r+", &error);
		if (!pipe_in)
			return;
		g_io_add_watch(pipe_in, G_IO_IN, pipe_read, NULL);
	}
}
