
#include <ocarina/songlist.h>

string formatted(string str)
{
	char *escaped = g_markup_escape_text(str.c_str(), -1);
	string ret = escaped;
	g_free(escaped);
	return ret;
}

void SongList::freeze()
{
	gtk_widget_freeze_child_notify(treeview);
	gtk_tree_view_set_model(GTK_TREE_VIEW(treeview), NULL);
}

void SongList::thaw()
{
	gtk_widget_thaw_child_notify(treeview);
	gtk_tree_view_set_model(GTK_TREE_VIEW(treeview), filter);
}

void SongList::clear()
{
	freeze();
	gtk_list_store_clear(liststore);
	thaw();
}

void SongList::insert(libsaria::Track *track)
{
	gtk_list_store_insert_with_values(liststore, NULL, ins_next,
		0, track->get_songid(),
		1, track->get_track(),
		2, track->get_title().c_str(),
		3, track->get_lenstr().c_str(),
		4, track->get_artist().c_str(),
		5, track->get_album().c_str(),
		6, track->get_year(),
		7, formatted(track->get_filepath()).c_str(),
		-1);
	ins_next++;
}

void SongList::fill()
{
	freeze();
	ins_next = 0;
	list_funcs->iter_reset();
	while (list_funcs->iter_end() == false)
		insert(list_funcs->iter_next());
	thaw();
	set_label_text();
}
